from pythonsnake import model, view
import keyboard
import time


def game_menu():

    while True:
        start_game(choose_mode())


def choose_mode():
    view.menu()

    choice = None
    while choice != "1" and choice != "2" and choice != "3":

        choice = input("=>")
        if choice != "1" and choice != "2" and choice != "3":
            view.menu_choice_incorrect()

    if choice == "3":
        exit()

    return int(choice)


def start_game(mode):
    gameState = model.Game(14)

    if mode == 1:
        start_game_terminal(gameState)
    elif mode == 2:
        start_game_UI(gameState)


def start_game_terminal(gameState):
    view.refresh_grid(gameState)

    keyboard.unhook_all()
    listen_escape_game(gameState)
    listen_move(gameState)

    while not gameState.lost:
        continue

    time.sleep(1)
    keyboard.unhook_all()


def start_game_UI(game):
    pass


def listen_escape_game(gameState):
    keyboard.on_press_key("esc", lambda _: gameState.exit_game())


def listen_move(gameState):
    keyboard.on_press_key(
        "left arrow", lambda _: view.refresh_grid(gameState.move("left arrow"))
    )
    keyboard.on_press_key(
        "right arrow", lambda _: view.refresh_grid(gameState.move("right arrow"))
    )
    keyboard.on_press_key(
        "up arrow", lambda _: view.refresh_grid(gameState.move("up arrow"))
    )
    keyboard.on_press_key(
        "down arrow", lambda _: view.refresh_grid(gameState.move("down arrow"))
    )
