from pythonsnake import terminalColor
import os


def cls():
    os.system("cls" if os.name == "nt" else "clear")


def refresh_grid(gameState):
    grid_to_print = ""
    for coordY, line in enumerate(gameState.grid):
        # if first row, display the top border
        if coordY == 0:
            grid_to_print += "_" * len(line) * 2
            grid_to_print += "\n"

        for coordX, column in enumerate(line):

            # if left border, display border
            if coordX == 0:
                grid_to_print += "|"

            # display user
            if (
                coordY == gameState.player_coord[1]
                and coordX == gameState.player_coord[0]
            ):
                grid_to_print += " X"  # type: ignore
            else:
                grid_to_print += "  "  # type: ignore

            # if right border, display border
            if coordX == len(line) - 1:
                grid_to_print += "|\n"

    # if first row, display the top border
    if coordY == len(gameState.grid) - 1:
        grid_to_print += "\u203E" * len(line) * 2
        grid_to_print += "\n"

    if gameState.lost:
        grid_to_print += (
            terminalColor.FAIL
            + terminalColor.BOLD
            + terminalColor.UNDERLINE
            + "Vous avez perdu !!!"
            + terminalColor.ENDC
            + "\n"
        )

    grid_to_print += (
        terminalColor.OKCYAN
        + "pour revenir au menu, appuyer sur la touche (Esc)"
        + terminalColor.ENDC
    )

    cls()
    print(grid_to_print, end="\r")


def menu():
    cls()
    menu = (
        terminalColor.OKGREEN
        + terminalColor.BOLD
        + "Bienvenue dans python Snake"
        + terminalColor.ENDC
        + "\n"
        + "que souhaitez vous faire:\n"
        + "1) jouer dans la console\n"
        + "2) jouer avec une Interface\n"
        + "3) Quitter\n"
    )
    print(menu, end="\r")


def menu_choice_incorrect():
    print(terminalColor.FAIL, "le choix n'est pas correct", terminalColor.ENDC)
